﻿Public Class ToolBox

    Public Shared Property DispatchService() As DispatchService
        Get
            Return m_DispatchService
        End Get
        Private Set(ByVal value As DispatchService)
            m_DispatchService = Value
        End Set
    End Property
    Private Shared m_DispatchService As DispatchService

    Public Shared Sub Initialize(ByVal dispatchService__1 As DispatchService)
        DispatchService = dispatchService__1
    End Sub

    Public Shared Sub DispatchToUI(ByVal action As Action, Optional ByVal isSynchronous As Boolean = False)
        If DispatchService.CheckAccess() Then
            action()
        Else
            If isSynchronous Then
                DispatchService.Invoke(action)
            Else
                DispatchService.BeginInvoke(action)
            End If
        End If
    End Sub
End Class